% Created by John Hedengren

global u

% Number of internal nodes
n = 20;

% Steady State Initial Conditions for the borders
u(1) = 25 + 273.15;
u(2) = 25 + 273.15;

% Steady State Initial Conditions for the States
for i = 2:n+1,
   T0(i) = 25 + 273.15;
end

% Change temperature on the left side
u(1) = 100 + 273.15;


% Initial conditions
x0(1:n,1) = T0(2:n+1)';

x_store = [];

for i = 1:10
   u(1) = rand(1)*150 + 273.15;
   u(1)
   
	% Final Time (sec)
	tf = 1000;
	tspan = linspace(0,tf,20);

	[t,x] = ode15s('heat1d',tspan,x0);

	x_store = [x_store; x];

	% record initial conditions for the next step
	x0 = x(size(x,1),:)';
end

   
% Use covariance matrix instead of raw data
% This performed better
x_cov = cov(x_store);
% The correlation matrix didn't work as well
%x_corr = corrcoef(x_store)

% Generate Eigenfunction optimal basis
%[U,S,V] = svd(x_store);
[U,S,V] = svd(x_cov);
T = V';
S_values = diag(S);
bar(S_values);
invT = inv(T);
save 'T_matrix_POD' T invT




